Index: common/func_validate_configs.sh
===================================================================
--- common/func_validate_configs.sh	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ common/func_validate_configs.sh	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -37,6 +37,6 @@
    "x86_64-64")  [[ "${TARGET}" = "x86_64-unknown-linux-gnu" ]] && return
     ;;
-   "mips64-64")  [[ "${TARGET}" = "mipsel-unknown-linux-gnu" ]] && return
-                 [[ "${TARGET}" = "mips-unknown-linux-gnu"   ]] && return
+   "mips64-64")  [[ "${TARGET}" = "mips64el-unknown-linux-gnu" ]] && return
+                 [[ "${TARGET}" = "mips64-unknown-linux-gnu"   ]] && return
     ;;
    "sparc64-64") [[ "${TARGET}" = "sparc64-unknown-linux-gnu" ]] && return
@@ -47,15 +47,17 @@
                  [[ "${TARGET32}" = "i686-pc-linux-gnu" ]] && return
     ;;
-   "mips64")     [[ "${TARGET}"   = "mipsel-unknown-linux-gnu" ]] &&
+   "mips64")     [[ "${TARGET}"   = "mips64el-unknown-linux-gnu" ]] &&
                  [[ "${TARGET32}" = "mipsel-unknown-linux-gnu" ]] && return
 
-                 [[ "${TARGET}"   = "mips-unknown-linux-gnu" ]] &&
+                 [[ "${TARGET}"   = "mips64-unknown-linux-gnu" ]] &&
                  [[ "${TARGET32}" = "mips-unknown-linux-gnu" ]] && return
     ;;
    "sparc64")    [[ "${TARGET}"   = "sparc64-unknown-linux-gnu" ]] &&
-                 [[ "${TARGET32}" = "sparcv9-unknown-linux-gnu" ]] && return
+                 [[ "${TARGET32}" = "sparc-unknown-linux-gnu" ]] && return
     ;;
    "ppc64")      [[ "${TARGET}"   = "powerpc64-unknown-linux-gnu" ]] &&
                  [[ "${TARGET32}" = "powerpc-unknown-linux-gnu"   ]] && return
+    ;;
+   "arm")        [[ "${TARGET}"   = "arm-unknown-linux-gnu" ]] && return
     ;;
    *)  write_error_and_die
@@ -85,7 +87,8 @@
 
   # First internal variables, then the ones that change the book's flavour, and lastly system configuration variables
-  local -r hlfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE MODEL GRSECURITY_HOST TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB             CONFIG GETKERNEL KEYMAP         PAGE TIMEZONE LANG LC_ALL"
-  local -r clfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE METHOD  ARCH  TARGET  TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB BOOT_CONFIG CONFIG GETKERNEL KEYMAP VIMLANG PAGE TIMEZONE LANG"
-  local -r  lfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE                       TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB             CONFIG GETKERNEL        VIMLANG PAGE TIMEZONE LANG"
+  local -r  hlfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE MODEL GRSECURITY_HOST TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB             CONFIG GETKERNEL KEYMAP         PAGE TIMEZONE LANG LC_ALL"
+  local -r  clfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE METHOD  ARCH  TARGET  TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB BOOT_CONFIG CONFIG GETKERNEL KEYMAP VIMLANG PAGE TIMEZONE LANG"
+  local -r clfs2_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE         ARCH  TARGET       OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB             CONFIG GETKERNEL KEYMAP VIMLANG PAGE TIMEZONE LANG"
+  local -r   lfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE                       TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB             CONFIG GETKERNEL        VIMLANG PAGE TIMEZONE LANG"
 
   local -r ERROR_MSG_pt1='The variable \"${L_arrow}${config_param}${R_arrow}\" value ${L_arrow}${BOLD}${!config_param}${R_arrow} is invalid,'
@@ -209,5 +212,5 @@
       PAGE)       validate_against_str "xletterx xA4x" ;;
       METHOD)     validate_against_str "xchrootx xbootx" ;;
-      ARCH)       validate_against_str "xx86x xx86_64x xx86_64-64x xsparcx xsparc64x xsparc64-64x xmipsx xmips64x xmips64-64x xppcx xppc64x xalphax" ;;
+      ARCH)       validate_against_str "xx86x xx86_64x xx86_64-64x xsparcx xsparc64x xsparc64-64x xmipsx xmips64x xmips64-64x xppcx xppc64x xalphax xarmx" ;;
       TARGET)     validate_target ;;
       GRSECURITY_HOST)  validate_against_str "x0x x1x" ;;
@@ -217,5 +220,5 @@
                      validate_dir -z -d
                    else
-                     validate_against_str "x${PROGNAME}-developmentx"
+                     validate_against_str "x${PROGNAME}-${LFSVRS}x"
                    fi ;;
 
Index: common/makefile-functions
===================================================================
--- common/makefile-functions	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ common/makefile-functions	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -55,9 +55,9 @@
   @echo -e \\t- Enter to the chroot using the command found
   @echo -e \\tin the section -Entering the Chroot Environment-
-  @echo -e \\texcept if building CLFS with METHOO=boot.
+  @echo -e \\texcept if building CLFS with METHOD=boot.
   @echo
   @echo -e \\t- Set a password for the root user.
   @echo
-  @echo -e \\t- Edit /etc/fstab, /etc/hosts, /etc/sysconfig/clock,
+  @echo -e \\t- Edit or create /etc/fstab, /etc/hosts, /etc/sysconfig/clock,
   @echo -e \\t/etc/sysconfig/console, /etc/sysconfig/network,
   @echo -e \\t/etc/sysconfig//network-devices/ifconfig.eth0/ipv4 and
@@ -66,9 +66,9 @@
   @echo -e \\t- Exit from the chroot.
   @echo
-  @echo -e \\t- Set-up the boot loader, except if building CLFS with METHOO=boot.
+  @echo -e \\t- Set-up the boot loader, except if building CLFS with METHOD=boot.
   @echo -e \\tYou can set-up the host bootloader or the new boot-loader
   @echo -e \\tinstalled on the new system.
   @echo -e \\tIf the last, you must to mount the virtual filesystems, re-enter
-  @echo -e \\tto the chroot and be sure that /dev is populated with the
+  @echo -e \\tthe chroot and be sure that /dev is populated with the
   @echo -e \\trequired devices before configure the boot-loader. When ready,
   @echo -e \\texit from the chroot and umount the filesystems
@@ -93,5 +93,5 @@
   @echo The build is not complete. Follow the next steps:$(WHITE)
   @echo
-  @echo -e \\t- Edit $(MOUNT_PT)/etc/fstab
+  @echo -e \\t- Edit or create $(MOUNT_PT)/etc/fstab
   @echo -e \\t and any other configuration file required to suit your needs.
   @echo $(BOLD)
Index: common/packages.xsl
===================================================================
--- common/packages.xsl	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
+++ common/packages.xsl	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -0,0 +1,46 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+
+<!-- $Id$ -->
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+    version="1.0">
+
+  <xsl:output method="text"/>
+
+  <xsl:template match="/">
+    <xsl:apply-templates select="//para"/>
+  </xsl:template>
+
+  <xsl:template match="para">
+    <xsl:if test="contains(string(),'Download:')">
+      <xsl:call-template name="package_name">
+        <xsl:with-param name="url" select="ulink/@url"/>
+      </xsl:call-template>
+      <xsl:text>&#xA;</xsl:text>
+    </xsl:if>
+  </xsl:template>
+
+  <xsl:template name="package_name">
+    <xsl:param name="url" select="foo"/>
+    <xsl:param name="sub-url" select="substring-after($url,'/')"/>
+    <xsl:choose>
+      <xsl:when test="contains($sub-url,'/')">
+        <xsl:call-template name="package_name">
+          <xsl:with-param name="url" select="$sub-url"/>
+        </xsl:call-template>
+      </xsl:when>
+      <xsl:otherwise>
+        <xsl:choose>
+          <xsl:when test="contains($sub-url,'.patch')"/>
+          <xsl:when test="contains($sub-url,'?')">
+            <xsl:value-of select="substring-before($sub-url,'?')"/>
+          </xsl:when>
+          <xsl:otherwise>
+            <xsl:value-of select="$sub-url"/>
+          </xsl:otherwise>
+        </xsl:choose>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: common/progress_bar.sh
===================================================================
--- common/progress_bar.sh	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ common/progress_bar.sh	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -22,12 +22,14 @@
 declare -i  PREV_SEC=0
 
+makePID=$(fuser -v . 2>&1 | grep make)
+makePID=$(echo $makePID | cut -d" " -f2)
 
 write_or_exit() {
     # make has been killed or failed or run to completion, leave
-  if ! fuser -v . 2>&1 | grep make >/dev/null ; then
-     echo -n "${CURSOR_ON}" && exit
-  fi
+  [[ ! -e /proc/$makePID ]] && echo -n "${CURSOR_ON}" && exit
+
     # Target build complete, leave.
   [[ -f ${TARGET} ]] && echo -n "${CURSOR_ON}" && exit
+
     # It is safe to write to the screen
   echo -n "$1"
Index: master.sh
===================================================================
--- master.sh	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ master.sh	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -106,20 +106,21 @@
         dev* | SVN | trunk )
           LFSVRS=development
-          ;;
-        *) if [[ "$PROGNAME" = "lfs" ]]; then
-             case $1 in
-               6.1.1 )
-                 echo "For stable 6.1.1 book, please use jhalfs-0.2."
-                 exit 0
-                ;;
-               * )
-                 echo "$1 is an unsupported version at this time."
-                 exit 0
-                ;;
-             esac
-           else
-             echo "The requested version, ${L_arrow} ${BOLD}$1${OFF} ${R_arrow}, is undefined in the ${BOLD}$(echo $PROGNAME | tr [a-z] [A-Z])${OFF} series."
-             exit 0
-           fi
+          TREE=trunk/BOOK
+          ;;
+        branch-* )
+          LFSVRS=$1
+          TREE=branches/${1#branch-}/BOOK
+          ;;
+        * )
+          case $PROGNAME in
+            lfs | hlfs )
+              LFSVRS=$1
+              TREE=tags/$1/BOOK
+              ;;
+            clfs )
+              LFSVRS=$1
+              TREE=tags/$1
+              ;;
+          esac
           ;;
       esac
@@ -193,5 +194,5 @@
             BOOK=$1
           else
-            echo -e "\nLooks like $1 isn't a LFS working copy."
+            echo -e "\nLooks like $1 isn't an LFS working copy."
             exit 1
           fi
@@ -211,5 +212,5 @@
             BOOK=$1
           else
-            echo -e "\nLooks like $1 isn't a HLFS working copy."
+            echo -e "\nLooks like $1 isn't an HLFS working copy."
             exit 1
           fi
@@ -218,5 +219,5 @@
       ;;
 
-    --comparasion | -C )
+    --comparison | -C )
       test $# = 1 && eval "$exit_missing_arg"
       shift
@@ -263,5 +264,5 @@
       ;;
 
-    --make | -M )          RUNMAKE=1 ;;
+    --run-make | -M )      RUNMAKE=1 ;;
 
     --rebuild | -R )       CLEAN=1   ;;
@@ -272,4 +273,8 @@
       shift
       case $1 in
+        arm )
+          ARCH=arm
+          TARGET="arm-unknown-linux-gnu"
+          ;;
         x86 )
           ARCH=x86
@@ -346,5 +351,5 @@
           ;;
         * )
-          echo -e "\n$1 is an unknown or unsopported arch."
+          echo -e "\n$1 is an unknown or unsupported arch."
           exit 1
           ;;
@@ -411,5 +416,5 @@
 
 
-# Check for minumum gcc and kernel versions
+# Check for minimum gcc and kernel versions
 #check_requirements  1 # 0/1  0-do not display values.
 echo
@@ -494,5 +499,5 @@
   #
   if [[ -n "$FILES" ]]; then
-    # pushd/popd necessary to deal with mulitiple files
+    # pushd/popd necessary to deal with multiple files
     pushd $PACKAGE_DIR 1> /dev/null
       cp $FILES $JHALFSDIR/
@@ -502,5 +507,5 @@
   if [[ "$REPORT" = "1" ]]; then
     cp $COMMON_DIR/create-sbu_du-report.sh  $JHALFSDIR/
-    # After be sure that all look sane, dump the settings to a file
+    # After being sure that all looks sane, dump the settings to a file
     # This file will be used to create the REPORT header
     validate_config > $JHALFSDIR/jhalfs.config
@@ -509,4 +514,6 @@
   [[ "$GETPKG" = "1" ]] && cp $COMMON_DIR/urls.xsl  $JHALFSDIR/
   #
+  cp $COMMON_DIR/packages.xsl  $JHALFSDIR/
+  #
   sed 's,FAKEDIR,'$BOOK',' $PACKAGE_DIR/$XSL > $JHALFSDIR/${XSL}
   export XSL=$JHALFSDIR/${XSL}
